<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XECMDocumentAddObjectOutputData StructType
 * @subpackage Structs
 */
class XECMDocumentAddObjectOutputData extends AbstractStructBase
{
    /**
     * The ReturnedStatus
     * Meta information extracted from the WSDL
     * - nillable: false
     * @var string
     */
    public $ReturnedStatus;
    /**
     * The ddapi193sReturnCode
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $ddapi193sReturnCode;
    /**
     * The documentId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentId;
    /**
     * The ddapi193sOutputReserved
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $ddapi193sOutputReserved;
    /**
     * Constructor method for XECMDocumentAddObjectOutputData
     * @uses XECMDocumentAddObjectOutputData::setReturnedStatus()
     * @uses XECMDocumentAddObjectOutputData::setDdapi193sReturnCode()
     * @uses XECMDocumentAddObjectOutputData::setDocumentId()
     * @uses XECMDocumentAddObjectOutputData::setDdapi193sOutputReserved()
     * @param string $returnedStatus
     * @param string $ddapi193sReturnCode
     * @param string $documentId
     * @param string $ddapi193sOutputReserved
     */
    public function __construct($returnedStatus = null, $ddapi193sReturnCode = null, $documentId = null, $ddapi193sOutputReserved = null)
    {
        $this
            ->setReturnedStatus($returnedStatus)
            ->setDdapi193sReturnCode($ddapi193sReturnCode)
            ->setDocumentId($documentId)
            ->setDdapi193sOutputReserved($ddapi193sOutputReserved);
    }
    /**
     * Get ReturnedStatus value
     * @return string|null
     */
    public function getReturnedStatus()
    {
        return $this->ReturnedStatus;
    }
    /**
     * Set ReturnedStatus value
     * @param string $returnedStatus
     * @return \StructType\XECMDocumentAddObjectOutputData
     */
    public function setReturnedStatus($returnedStatus = null)
    {
        // validation for constraint: string
        if (!is_null($returnedStatus) && !is_string($returnedStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($returnedStatus, true), gettype($returnedStatus)), __LINE__);
        }
        $this->ReturnedStatus = $returnedStatus;
        return $this;
    }
    /**
     * Get ddapi193sReturnCode value
     * @return string|null
     */
    public function getDdapi193sReturnCode()
    {
        return $this->ddapi193sReturnCode;
    }
    /**
     * Set ddapi193sReturnCode value
     * @param string $ddapi193sReturnCode
     * @return \StructType\XECMDocumentAddObjectOutputData
     */
    public function setDdapi193sReturnCode($ddapi193sReturnCode = null)
    {
        // validation for constraint: string
        if (!is_null($ddapi193sReturnCode) && !is_string($ddapi193sReturnCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ddapi193sReturnCode, true), gettype($ddapi193sReturnCode)), __LINE__);
        }
        $this->ddapi193sReturnCode = $ddapi193sReturnCode;
        return $this;
    }
    /**
     * Get documentId value
     * @return string|null
     */
    public function getDocumentId()
    {
        return $this->documentId;
    }
    /**
     * Set documentId value
     * @param string $documentId
     * @return \StructType\XECMDocumentAddObjectOutputData
     */
    public function setDocumentId($documentId = null)
    {
        // validation for constraint: string
        if (!is_null($documentId) && !is_string($documentId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentId, true), gettype($documentId)), __LINE__);
        }
        $this->documentId = $documentId;
        return $this;
    }
    /**
     * Get ddapi193sOutputReserved value
     * @return string|null
     */
    public function getDdapi193sOutputReserved()
    {
        return $this->ddapi193sOutputReserved;
    }
    /**
     * Set ddapi193sOutputReserved value
     * @param string $ddapi193sOutputReserved
     * @return \StructType\XECMDocumentAddObjectOutputData
     */
    public function setDdapi193sOutputReserved($ddapi193sOutputReserved = null)
    {
        // validation for constraint: string
        if (!is_null($ddapi193sOutputReserved) && !is_string($ddapi193sOutputReserved)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ddapi193sOutputReserved, true), gettype($ddapi193sOutputReserved)), __LINE__);
        }
        $this->ddapi193sOutputReserved = $ddapi193sOutputReserved;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\XECMDocumentAddObjectOutputData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
