<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XECMDocumentChangeObjectOutputData StructType
 * @subpackage Structs
 */
class XECMDocumentChangeObjectOutputData extends AbstractStructBase
{
    /**
     * The ReturnedStatus
     * Meta information extracted from the WSDL
     * - nillable: false
     * @var string
     */
    public $ReturnedStatus;
    /**
     * The ddapi145sReturnCode
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $ddapi145sReturnCode;
    /**
     * The documentId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentId;
    /**
     * The ddapi145sOutputReserved
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $ddapi145sOutputReserved;
    /**
     * Constructor method for XECMDocumentChangeObjectOutputData
     * @uses XECMDocumentChangeObjectOutputData::setReturnedStatus()
     * @uses XECMDocumentChangeObjectOutputData::setDdapi145sReturnCode()
     * @uses XECMDocumentChangeObjectOutputData::setDocumentId()
     * @uses XECMDocumentChangeObjectOutputData::setDdapi145sOutputReserved()
     * @param string $returnedStatus
     * @param string $ddapi145sReturnCode
     * @param string $documentId
     * @param string $ddapi145sOutputReserved
     */
    public function __construct($returnedStatus = null, $ddapi145sReturnCode = null, $documentId = null, $ddapi145sOutputReserved = null)
    {
        $this
            ->setReturnedStatus($returnedStatus)
            ->setDdapi145sReturnCode($ddapi145sReturnCode)
            ->setDocumentId($documentId)
            ->setDdapi145sOutputReserved($ddapi145sOutputReserved);
    }
    /**
     * Get ReturnedStatus value
     * @return string|null
     */
    public function getReturnedStatus()
    {
        return $this->ReturnedStatus;
    }
    /**
     * Set ReturnedStatus value
     * @param string $returnedStatus
     * @return \StructType\XECMDocumentChangeObjectOutputData
     */
    public function setReturnedStatus($returnedStatus = null)
    {
        // validation for constraint: string
        if (!is_null($returnedStatus) && !is_string($returnedStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($returnedStatus, true), gettype($returnedStatus)), __LINE__);
        }
        $this->ReturnedStatus = $returnedStatus;
        return $this;
    }
    /**
     * Get ddapi145sReturnCode value
     * @return string|null
     */
    public function getDdapi145sReturnCode()
    {
        return $this->ddapi145sReturnCode;
    }
    /**
     * Set ddapi145sReturnCode value
     * @param string $ddapi145sReturnCode
     * @return \StructType\XECMDocumentChangeObjectOutputData
     */
    public function setDdapi145sReturnCode($ddapi145sReturnCode = null)
    {
        // validation for constraint: string
        if (!is_null($ddapi145sReturnCode) && !is_string($ddapi145sReturnCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ddapi145sReturnCode, true), gettype($ddapi145sReturnCode)), __LINE__);
        }
        $this->ddapi145sReturnCode = $ddapi145sReturnCode;
        return $this;
    }
    /**
     * Get documentId value
     * @return string|null
     */
    public function getDocumentId()
    {
        return $this->documentId;
    }
    /**
     * Set documentId value
     * @param string $documentId
     * @return \StructType\XECMDocumentChangeObjectOutputData
     */
    public function setDocumentId($documentId = null)
    {
        // validation for constraint: string
        if (!is_null($documentId) && !is_string($documentId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentId, true), gettype($documentId)), __LINE__);
        }
        $this->documentId = $documentId;
        return $this;
    }
    /**
     * Get ddapi145sOutputReserved value
     * @return string|null
     */
    public function getDdapi145sOutputReserved()
    {
        return $this->ddapi145sOutputReserved;
    }
    /**
     * Set ddapi145sOutputReserved value
     * @param string $ddapi145sOutputReserved
     * @return \StructType\XECMDocumentChangeObjectOutputData
     */
    public function setDdapi145sOutputReserved($ddapi145sOutputReserved = null)
    {
        // validation for constraint: string
        if (!is_null($ddapi145sOutputReserved) && !is_string($ddapi145sOutputReserved)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ddapi145sOutputReserved, true), gettype($ddapi145sOutputReserved)), __LINE__);
        }
        $this->ddapi145sOutputReserved = $ddapi145sOutputReserved;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\XECMDocumentChangeObjectOutputData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
