<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XECMDocumentCopySingleInstanceAndObjectOutputData
 * StructType
 * @subpackage Structs
 */
class XECMDocumentCopySingleInstanceAndObjectOutputData extends AbstractStructBase
{
    /**
     * The ReturnedStatus
     * Meta information extracted from the WSDL
     * - nillable: false
     * @var string
     */
    public $ReturnedStatus;
    /**
     * The documentId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentId;
    /**
     * The databaseId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $databaseId;
    /**
     * The editorId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $editorId;
    /**
     * The primaryStorageHostAlias
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $primaryStorageHostAlias;
    /**
     * The primaryStorageClientAlias
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $primaryStorageClientAlias;
    /**
     * The primaryStoragePath
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $primaryStoragePath;
    /**
     * The documentNumber
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentNumber;
    /**
     * The documentVersionNumber
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentVersionNumber;
    /**
     * Constructor method for XECMDocumentCopySingleInstanceAndObjectOutputData
     * @uses XECMDocumentCopySingleInstanceAndObjectOutputData::setReturnedStatus()
     * @uses XECMDocumentCopySingleInstanceAndObjectOutputData::setDocumentId()
     * @uses XECMDocumentCopySingleInstanceAndObjectOutputData::setDatabaseId()
     * @uses XECMDocumentCopySingleInstanceAndObjectOutputData::setEditorId()
     * @uses XECMDocumentCopySingleInstanceAndObjectOutputData::setPrimaryStorageHostAlias()
     * @uses XECMDocumentCopySingleInstanceAndObjectOutputData::setPrimaryStorageClientAlias()
     * @uses XECMDocumentCopySingleInstanceAndObjectOutputData::setPrimaryStoragePath()
     * @uses XECMDocumentCopySingleInstanceAndObjectOutputData::setDocumentNumber()
     * @uses XECMDocumentCopySingleInstanceAndObjectOutputData::setDocumentVersionNumber()
     * @param string $returnedStatus
     * @param string $documentId
     * @param string $databaseId
     * @param string $editorId
     * @param string $primaryStorageHostAlias
     * @param string $primaryStorageClientAlias
     * @param string $primaryStoragePath
     * @param string $documentNumber
     * @param string $documentVersionNumber
     */
    public function __construct($returnedStatus = null, $documentId = null, $databaseId = null, $editorId = null, $primaryStorageHostAlias = null, $primaryStorageClientAlias = null, $primaryStoragePath = null, $documentNumber = null, $documentVersionNumber = null)
    {
        $this
            ->setReturnedStatus($returnedStatus)
            ->setDocumentId($documentId)
            ->setDatabaseId($databaseId)
            ->setEditorId($editorId)
            ->setPrimaryStorageHostAlias($primaryStorageHostAlias)
            ->setPrimaryStorageClientAlias($primaryStorageClientAlias)
            ->setPrimaryStoragePath($primaryStoragePath)
            ->setDocumentNumber($documentNumber)
            ->setDocumentVersionNumber($documentVersionNumber);
    }
    /**
     * Get ReturnedStatus value
     * @return string|null
     */
    public function getReturnedStatus()
    {
        return $this->ReturnedStatus;
    }
    /**
     * Set ReturnedStatus value
     * @param string $returnedStatus
     * @return \StructType\XECMDocumentCopySingleInstanceAndObjectOutputData
     */
    public function setReturnedStatus($returnedStatus = null)
    {
        // validation for constraint: string
        if (!is_null($returnedStatus) && !is_string($returnedStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($returnedStatus, true), gettype($returnedStatus)), __LINE__);
        }
        $this->ReturnedStatus = $returnedStatus;
        return $this;
    }
    /**
     * Get documentId value
     * @return string|null
     */
    public function getDocumentId()
    {
        return $this->documentId;
    }
    /**
     * Set documentId value
     * @param string $documentId
     * @return \StructType\XECMDocumentCopySingleInstanceAndObjectOutputData
     */
    public function setDocumentId($documentId = null)
    {
        // validation for constraint: string
        if (!is_null($documentId) && !is_string($documentId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentId, true), gettype($documentId)), __LINE__);
        }
        $this->documentId = $documentId;
        return $this;
    }
    /**
     * Get databaseId value
     * @return string|null
     */
    public function getDatabaseId()
    {
        return $this->databaseId;
    }
    /**
     * Set databaseId value
     * @param string $databaseId
     * @return \StructType\XECMDocumentCopySingleInstanceAndObjectOutputData
     */
    public function setDatabaseId($databaseId = null)
    {
        // validation for constraint: string
        if (!is_null($databaseId) && !is_string($databaseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($databaseId, true), gettype($databaseId)), __LINE__);
        }
        $this->databaseId = $databaseId;
        return $this;
    }
    /**
     * Get editorId value
     * @return string|null
     */
    public function getEditorId()
    {
        return $this->editorId;
    }
    /**
     * Set editorId value
     * @param string $editorId
     * @return \StructType\XECMDocumentCopySingleInstanceAndObjectOutputData
     */
    public function setEditorId($editorId = null)
    {
        // validation for constraint: string
        if (!is_null($editorId) && !is_string($editorId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($editorId, true), gettype($editorId)), __LINE__);
        }
        $this->editorId = $editorId;
        return $this;
    }
    /**
     * Get primaryStorageHostAlias value
     * @return string|null
     */
    public function getPrimaryStorageHostAlias()
    {
        return $this->primaryStorageHostAlias;
    }
    /**
     * Set primaryStorageHostAlias value
     * @param string $primaryStorageHostAlias
     * @return \StructType\XECMDocumentCopySingleInstanceAndObjectOutputData
     */
    public function setPrimaryStorageHostAlias($primaryStorageHostAlias = null)
    {
        // validation for constraint: string
        if (!is_null($primaryStorageHostAlias) && !is_string($primaryStorageHostAlias)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($primaryStorageHostAlias, true), gettype($primaryStorageHostAlias)), __LINE__);
        }
        $this->primaryStorageHostAlias = $primaryStorageHostAlias;
        return $this;
    }
    /**
     * Get primaryStorageClientAlias value
     * @return string|null
     */
    public function getPrimaryStorageClientAlias()
    {
        return $this->primaryStorageClientAlias;
    }
    /**
     * Set primaryStorageClientAlias value
     * @param string $primaryStorageClientAlias
     * @return \StructType\XECMDocumentCopySingleInstanceAndObjectOutputData
     */
    public function setPrimaryStorageClientAlias($primaryStorageClientAlias = null)
    {
        // validation for constraint: string
        if (!is_null($primaryStorageClientAlias) && !is_string($primaryStorageClientAlias)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($primaryStorageClientAlias, true), gettype($primaryStorageClientAlias)), __LINE__);
        }
        $this->primaryStorageClientAlias = $primaryStorageClientAlias;
        return $this;
    }
    /**
     * Get primaryStoragePath value
     * @return string|null
     */
    public function getPrimaryStoragePath()
    {
        return $this->primaryStoragePath;
    }
    /**
     * Set primaryStoragePath value
     * @param string $primaryStoragePath
     * @return \StructType\XECMDocumentCopySingleInstanceAndObjectOutputData
     */
    public function setPrimaryStoragePath($primaryStoragePath = null)
    {
        // validation for constraint: string
        if (!is_null($primaryStoragePath) && !is_string($primaryStoragePath)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($primaryStoragePath, true), gettype($primaryStoragePath)), __LINE__);
        }
        $this->primaryStoragePath = $primaryStoragePath;
        return $this;
    }
    /**
     * Get documentNumber value
     * @return string|null
     */
    public function getDocumentNumber()
    {
        return $this->documentNumber;
    }
    /**
     * Set documentNumber value
     * @param string $documentNumber
     * @return \StructType\XECMDocumentCopySingleInstanceAndObjectOutputData
     */
    public function setDocumentNumber($documentNumber = null)
    {
        // validation for constraint: string
        if (!is_null($documentNumber) && !is_string($documentNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentNumber, true), gettype($documentNumber)), __LINE__);
        }
        $this->documentNumber = $documentNumber;
        return $this;
    }
    /**
     * Get documentVersionNumber value
     * @return string|null
     */
    public function getDocumentVersionNumber()
    {
        return $this->documentVersionNumber;
    }
    /**
     * Set documentVersionNumber value
     * @param string $documentVersionNumber
     * @return \StructType\XECMDocumentCopySingleInstanceAndObjectOutputData
     */
    public function setDocumentVersionNumber($documentVersionNumber = null)
    {
        // validation for constraint: string
        if (!is_null($documentVersionNumber) && !is_string($documentVersionNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentVersionNumber, true), gettype($documentVersionNumber)), __LINE__);
        }
        $this->documentVersionNumber = $documentVersionNumber;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\XECMDocumentCopySingleInstanceAndObjectOutputData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
