<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XECMDocumentDeleteLinkInputData StructType
 * @subpackage Structs
 */
class XECMDocumentDeleteLinkInputData extends AbstractStructBase
{
    /**
     * The apiActionCode
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $apiActionCode;
    /**
     * The apiEnvironmentName
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $apiEnvironmentName;
    /**
     * The apiUserId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $apiUserId;
    /**
     * The apiRightsCheck
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $apiRightsCheck;
    /**
     * The documentId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentId;
    /**
     * The databaseId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $databaseId;
    /**
     * The documentTypeId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentTypeId;
    /**
     * The keywordTypeId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $keywordTypeId;
    /**
     * The keywordValue
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $keywordValue;
    /**
     * The documentNumber
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentNumber;
    /**
     * The documentVersionNumber
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentVersionNumber;
    /**
     * The XECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\XECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias
     */
    public $XECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias;
    /**
     * Constructor method for XECMDocumentDeleteLinkInputData
     * @uses XECMDocumentDeleteLinkInputData::setApiActionCode()
     * @uses XECMDocumentDeleteLinkInputData::setApiEnvironmentName()
     * @uses XECMDocumentDeleteLinkInputData::setApiUserId()
     * @uses XECMDocumentDeleteLinkInputData::setApiRightsCheck()
     * @uses XECMDocumentDeleteLinkInputData::setDocumentId()
     * @uses XECMDocumentDeleteLinkInputData::setDatabaseId()
     * @uses XECMDocumentDeleteLinkInputData::setDocumentTypeId()
     * @uses XECMDocumentDeleteLinkInputData::setKeywordTypeId()
     * @uses XECMDocumentDeleteLinkInputData::setKeywordValue()
     * @uses XECMDocumentDeleteLinkInputData::setDocumentNumber()
     * @uses XECMDocumentDeleteLinkInputData::setDocumentVersionNumber()
     * @uses XECMDocumentDeleteLinkInputData::setXECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias()
     * @param string $apiActionCode
     * @param string $apiEnvironmentName
     * @param string $apiUserId
     * @param string $apiRightsCheck
     * @param string $documentId
     * @param string $databaseId
     * @param string $documentTypeId
     * @param string $keywordTypeId
     * @param string $keywordValue
     * @param string $documentNumber
     * @param string $documentVersionNumber
     * @param \StructType\XECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias $xECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias
     */
    public function __construct($apiActionCode = null, $apiEnvironmentName = null, $apiUserId = null, $apiRightsCheck = null, $documentId = null, $databaseId = null, $documentTypeId = null, $keywordTypeId = null, $keywordValue = null, $documentNumber = null, $documentVersionNumber = null, \StructType\XECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias $xECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias = null)
    {
        $this
            ->setApiActionCode($apiActionCode)
            ->setApiEnvironmentName($apiEnvironmentName)
            ->setApiUserId($apiUserId)
            ->setApiRightsCheck($apiRightsCheck)
            ->setDocumentId($documentId)
            ->setDatabaseId($databaseId)
            ->setDocumentTypeId($documentTypeId)
            ->setKeywordTypeId($keywordTypeId)
            ->setKeywordValue($keywordValue)
            ->setDocumentNumber($documentNumber)
            ->setDocumentVersionNumber($documentVersionNumber)
            ->setXECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias($xECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias);
    }
    /**
     * Get apiActionCode value
     * @return string|null
     */
    public function getApiActionCode()
    {
        return $this->apiActionCode;
    }
    /**
     * Set apiActionCode value
     * @param string $apiActionCode
     * @return \StructType\XECMDocumentDeleteLinkInputData
     */
    public function setApiActionCode($apiActionCode = null)
    {
        // validation for constraint: string
        if (!is_null($apiActionCode) && !is_string($apiActionCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($apiActionCode, true), gettype($apiActionCode)), __LINE__);
        }
        $this->apiActionCode = $apiActionCode;
        return $this;
    }
    /**
     * Get apiEnvironmentName value
     * @return string|null
     */
    public function getApiEnvironmentName()
    {
        return $this->apiEnvironmentName;
    }
    /**
     * Set apiEnvironmentName value
     * @param string $apiEnvironmentName
     * @return \StructType\XECMDocumentDeleteLinkInputData
     */
    public function setApiEnvironmentName($apiEnvironmentName = null)
    {
        // validation for constraint: string
        if (!is_null($apiEnvironmentName) && !is_string($apiEnvironmentName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($apiEnvironmentName, true), gettype($apiEnvironmentName)), __LINE__);
        }
        $this->apiEnvironmentName = $apiEnvironmentName;
        return $this;
    }
    /**
     * Get apiUserId value
     * @return string|null
     */
    public function getApiUserId()
    {
        return $this->apiUserId;
    }
    /**
     * Set apiUserId value
     * @param string $apiUserId
     * @return \StructType\XECMDocumentDeleteLinkInputData
     */
    public function setApiUserId($apiUserId = null)
    {
        // validation for constraint: string
        if (!is_null($apiUserId) && !is_string($apiUserId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($apiUserId, true), gettype($apiUserId)), __LINE__);
        }
        $this->apiUserId = $apiUserId;
        return $this;
    }
    /**
     * Get apiRightsCheck value
     * @return string|null
     */
    public function getApiRightsCheck()
    {
        return $this->apiRightsCheck;
    }
    /**
     * Set apiRightsCheck value
     * @param string $apiRightsCheck
     * @return \StructType\XECMDocumentDeleteLinkInputData
     */
    public function setApiRightsCheck($apiRightsCheck = null)
    {
        // validation for constraint: string
        if (!is_null($apiRightsCheck) && !is_string($apiRightsCheck)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($apiRightsCheck, true), gettype($apiRightsCheck)), __LINE__);
        }
        $this->apiRightsCheck = $apiRightsCheck;
        return $this;
    }
    /**
     * Get documentId value
     * @return string|null
     */
    public function getDocumentId()
    {
        return $this->documentId;
    }
    /**
     * Set documentId value
     * @param string $documentId
     * @return \StructType\XECMDocumentDeleteLinkInputData
     */
    public function setDocumentId($documentId = null)
    {
        // validation for constraint: string
        if (!is_null($documentId) && !is_string($documentId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentId, true), gettype($documentId)), __LINE__);
        }
        $this->documentId = $documentId;
        return $this;
    }
    /**
     * Get databaseId value
     * @return string|null
     */
    public function getDatabaseId()
    {
        return $this->databaseId;
    }
    /**
     * Set databaseId value
     * @param string $databaseId
     * @return \StructType\XECMDocumentDeleteLinkInputData
     */
    public function setDatabaseId($databaseId = null)
    {
        // validation for constraint: string
        if (!is_null($databaseId) && !is_string($databaseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($databaseId, true), gettype($databaseId)), __LINE__);
        }
        $this->databaseId = $databaseId;
        return $this;
    }
    /**
     * Get documentTypeId value
     * @return string|null
     */
    public function getDocumentTypeId()
    {
        return $this->documentTypeId;
    }
    /**
     * Set documentTypeId value
     * @param string $documentTypeId
     * @return \StructType\XECMDocumentDeleteLinkInputData
     */
    public function setDocumentTypeId($documentTypeId = null)
    {
        // validation for constraint: string
        if (!is_null($documentTypeId) && !is_string($documentTypeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentTypeId, true), gettype($documentTypeId)), __LINE__);
        }
        $this->documentTypeId = $documentTypeId;
        return $this;
    }
    /**
     * Get keywordTypeId value
     * @return string|null
     */
    public function getKeywordTypeId()
    {
        return $this->keywordTypeId;
    }
    /**
     * Set keywordTypeId value
     * @param string $keywordTypeId
     * @return \StructType\XECMDocumentDeleteLinkInputData
     */
    public function setKeywordTypeId($keywordTypeId = null)
    {
        // validation for constraint: string
        if (!is_null($keywordTypeId) && !is_string($keywordTypeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($keywordTypeId, true), gettype($keywordTypeId)), __LINE__);
        }
        $this->keywordTypeId = $keywordTypeId;
        return $this;
    }
    /**
     * Get keywordValue value
     * @return string|null
     */
    public function getKeywordValue()
    {
        return $this->keywordValue;
    }
    /**
     * Set keywordValue value
     * @param string $keywordValue
     * @return \StructType\XECMDocumentDeleteLinkInputData
     */
    public function setKeywordValue($keywordValue = null)
    {
        // validation for constraint: string
        if (!is_null($keywordValue) && !is_string($keywordValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($keywordValue, true), gettype($keywordValue)), __LINE__);
        }
        $this->keywordValue = $keywordValue;
        return $this;
    }
    /**
     * Get documentNumber value
     * @return string|null
     */
    public function getDocumentNumber()
    {
        return $this->documentNumber;
    }
    /**
     * Set documentNumber value
     * @param string $documentNumber
     * @return \StructType\XECMDocumentDeleteLinkInputData
     */
    public function setDocumentNumber($documentNumber = null)
    {
        // validation for constraint: string
        if (!is_null($documentNumber) && !is_string($documentNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentNumber, true), gettype($documentNumber)), __LINE__);
        }
        $this->documentNumber = $documentNumber;
        return $this;
    }
    /**
     * Get documentVersionNumber value
     * @return string|null
     */
    public function getDocumentVersionNumber()
    {
        return $this->documentVersionNumber;
    }
    /**
     * Set documentVersionNumber value
     * @param string $documentVersionNumber
     * @return \StructType\XECMDocumentDeleteLinkInputData
     */
    public function setDocumentVersionNumber($documentVersionNumber = null)
    {
        // validation for constraint: string
        if (!is_null($documentVersionNumber) && !is_string($documentVersionNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentVersionNumber, true), gettype($documentVersionNumber)), __LINE__);
        }
        $this->documentVersionNumber = $documentVersionNumber;
        return $this;
    }
    /**
     * Get XECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias value
     * @return \StructType\XECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias|null
     */
    public function getXECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias()
    {
        return $this->XECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias;
    }
    /**
     * Set XECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias value
     * @param \StructType\XECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias $xECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias
     * @return \StructType\XECMDocumentDeleteLinkInputData
     */
    public function setXECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias(\StructType\XECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias $xECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias = null)
    {
        $this->XECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias = $xECMDocumentDeleteLinkInputDataSingleDocumentSearchCriterias;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\XECMDocumentDeleteLinkInputData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
