<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XECMDocumentDeleteLinkOutputData StructType
 * @subpackage Structs
 */
class XECMDocumentDeleteLinkOutputData extends AbstractStructBase
{
    /**
     * The ReturnedStatus
     * Meta information extracted from the WSDL
     * - nillable: false
     * @var string
     */
    public $ReturnedStatus;
    /**
     * The documentId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentId;
    /**
     * The linkedDocumentId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $linkedDocumentId;
    /**
     * Constructor method for XECMDocumentDeleteLinkOutputData
     * @uses XECMDocumentDeleteLinkOutputData::setReturnedStatus()
     * @uses XECMDocumentDeleteLinkOutputData::setDocumentId()
     * @uses XECMDocumentDeleteLinkOutputData::setLinkedDocumentId()
     * @param string $returnedStatus
     * @param string $documentId
     * @param string $linkedDocumentId
     */
    public function __construct($returnedStatus = null, $documentId = null, $linkedDocumentId = null)
    {
        $this
            ->setReturnedStatus($returnedStatus)
            ->setDocumentId($documentId)
            ->setLinkedDocumentId($linkedDocumentId);
    }
    /**
     * Get ReturnedStatus value
     * @return string|null
     */
    public function getReturnedStatus()
    {
        return $this->ReturnedStatus;
    }
    /**
     * Set ReturnedStatus value
     * @param string $returnedStatus
     * @return \StructType\XECMDocumentDeleteLinkOutputData
     */
    public function setReturnedStatus($returnedStatus = null)
    {
        // validation for constraint: string
        if (!is_null($returnedStatus) && !is_string($returnedStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($returnedStatus, true), gettype($returnedStatus)), __LINE__);
        }
        $this->ReturnedStatus = $returnedStatus;
        return $this;
    }
    /**
     * Get documentId value
     * @return string|null
     */
    public function getDocumentId()
    {
        return $this->documentId;
    }
    /**
     * Set documentId value
     * @param string $documentId
     * @return \StructType\XECMDocumentDeleteLinkOutputData
     */
    public function setDocumentId($documentId = null)
    {
        // validation for constraint: string
        if (!is_null($documentId) && !is_string($documentId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentId, true), gettype($documentId)), __LINE__);
        }
        $this->documentId = $documentId;
        return $this;
    }
    /**
     * Get linkedDocumentId value
     * @return string|null
     */
    public function getLinkedDocumentId()
    {
        return $this->linkedDocumentId;
    }
    /**
     * Set linkedDocumentId value
     * @param string $linkedDocumentId
     * @return \StructType\XECMDocumentDeleteLinkOutputData
     */
    public function setLinkedDocumentId($linkedDocumentId = null)
    {
        // validation for constraint: string
        if (!is_null($linkedDocumentId) && !is_string($linkedDocumentId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($linkedDocumentId, true), gettype($linkedDocumentId)), __LINE__);
        }
        $this->linkedDocumentId = $linkedDocumentId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\XECMDocumentDeleteLinkOutputData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
