<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XECMDocumentDisplayObjectOutputData StructType
 * @subpackage Structs
 */
class XECMDocumentDisplayObjectOutputData extends AbstractStructBase
{
    /**
     * The ReturnedStatus
     * Meta information extracted from the WSDL
     * - nillable: false
     * @var string
     */
    public $ReturnedStatus;
    /**
     * The ddapi91sReturnCode
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $ddapi91sReturnCode;
    /**
     * The documentId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentId;
    /**
     * The primaryStorageHostAlias
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $primaryStorageHostAlias;
    /**
     * The primaryStorageClientAlias
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $primaryStorageClientAlias;
    /**
     * The primaryStoragePath
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $primaryStoragePath;
    /**
     * The mainSecondaryStorageAlias
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $mainSecondaryStorageAlias;
    /**
     * The mainSecondaryStoragePath
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $mainSecondaryStoragePath;
    /**
     * The backupSecondaryStorageAlias
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $backupSecondaryStorageAlias;
    /**
     * The backupSecondaryStoragePath
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $backupSecondaryStoragePath;
    /**
     * The isDisplayable
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $isDisplayable;
    /**
     * The ddapi91sOutputReserved
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $ddapi91sOutputReserved;
    /**
     * Constructor method for XECMDocumentDisplayObjectOutputData
     * @uses XECMDocumentDisplayObjectOutputData::setReturnedStatus()
     * @uses XECMDocumentDisplayObjectOutputData::setDdapi91sReturnCode()
     * @uses XECMDocumentDisplayObjectOutputData::setDocumentId()
     * @uses XECMDocumentDisplayObjectOutputData::setPrimaryStorageHostAlias()
     * @uses XECMDocumentDisplayObjectOutputData::setPrimaryStorageClientAlias()
     * @uses XECMDocumentDisplayObjectOutputData::setPrimaryStoragePath()
     * @uses XECMDocumentDisplayObjectOutputData::setMainSecondaryStorageAlias()
     * @uses XECMDocumentDisplayObjectOutputData::setMainSecondaryStoragePath()
     * @uses XECMDocumentDisplayObjectOutputData::setBackupSecondaryStorageAlias()
     * @uses XECMDocumentDisplayObjectOutputData::setBackupSecondaryStoragePath()
     * @uses XECMDocumentDisplayObjectOutputData::setIsDisplayable()
     * @uses XECMDocumentDisplayObjectOutputData::setDdapi91sOutputReserved()
     * @param string $returnedStatus
     * @param string $ddapi91sReturnCode
     * @param string $documentId
     * @param string $primaryStorageHostAlias
     * @param string $primaryStorageClientAlias
     * @param string $primaryStoragePath
     * @param string $mainSecondaryStorageAlias
     * @param string $mainSecondaryStoragePath
     * @param string $backupSecondaryStorageAlias
     * @param string $backupSecondaryStoragePath
     * @param string $isDisplayable
     * @param string $ddapi91sOutputReserved
     */
    public function __construct($returnedStatus = null, $ddapi91sReturnCode = null, $documentId = null, $primaryStorageHostAlias = null, $primaryStorageClientAlias = null, $primaryStoragePath = null, $mainSecondaryStorageAlias = null, $mainSecondaryStoragePath = null, $backupSecondaryStorageAlias = null, $backupSecondaryStoragePath = null, $isDisplayable = null, $ddapi91sOutputReserved = null)
    {
        $this
            ->setReturnedStatus($returnedStatus)
            ->setDdapi91sReturnCode($ddapi91sReturnCode)
            ->setDocumentId($documentId)
            ->setPrimaryStorageHostAlias($primaryStorageHostAlias)
            ->setPrimaryStorageClientAlias($primaryStorageClientAlias)
            ->setPrimaryStoragePath($primaryStoragePath)
            ->setMainSecondaryStorageAlias($mainSecondaryStorageAlias)
            ->setMainSecondaryStoragePath($mainSecondaryStoragePath)
            ->setBackupSecondaryStorageAlias($backupSecondaryStorageAlias)
            ->setBackupSecondaryStoragePath($backupSecondaryStoragePath)
            ->setIsDisplayable($isDisplayable)
            ->setDdapi91sOutputReserved($ddapi91sOutputReserved);
    }
    /**
     * Get ReturnedStatus value
     * @return string|null
     */
    public function getReturnedStatus()
    {
        return $this->ReturnedStatus;
    }
    /**
     * Set ReturnedStatus value
     * @param string $returnedStatus
     * @return \StructType\XECMDocumentDisplayObjectOutputData
     */
    public function setReturnedStatus($returnedStatus = null)
    {
        // validation for constraint: string
        if (!is_null($returnedStatus) && !is_string($returnedStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($returnedStatus, true), gettype($returnedStatus)), __LINE__);
        }
        $this->ReturnedStatus = $returnedStatus;
        return $this;
    }
    /**
     * Get ddapi91sReturnCode value
     * @return string|null
     */
    public function getDdapi91sReturnCode()
    {
        return $this->ddapi91sReturnCode;
    }
    /**
     * Set ddapi91sReturnCode value
     * @param string $ddapi91sReturnCode
     * @return \StructType\XECMDocumentDisplayObjectOutputData
     */
    public function setDdapi91sReturnCode($ddapi91sReturnCode = null)
    {
        // validation for constraint: string
        if (!is_null($ddapi91sReturnCode) && !is_string($ddapi91sReturnCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ddapi91sReturnCode, true), gettype($ddapi91sReturnCode)), __LINE__);
        }
        $this->ddapi91sReturnCode = $ddapi91sReturnCode;
        return $this;
    }
    /**
     * Get documentId value
     * @return string|null
     */
    public function getDocumentId()
    {
        return $this->documentId;
    }
    /**
     * Set documentId value
     * @param string $documentId
     * @return \StructType\XECMDocumentDisplayObjectOutputData
     */
    public function setDocumentId($documentId = null)
    {
        // validation for constraint: string
        if (!is_null($documentId) && !is_string($documentId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentId, true), gettype($documentId)), __LINE__);
        }
        $this->documentId = $documentId;
        return $this;
    }
    /**
     * Get primaryStorageHostAlias value
     * @return string|null
     */
    public function getPrimaryStorageHostAlias()
    {
        return $this->primaryStorageHostAlias;
    }
    /**
     * Set primaryStorageHostAlias value
     * @param string $primaryStorageHostAlias
     * @return \StructType\XECMDocumentDisplayObjectOutputData
     */
    public function setPrimaryStorageHostAlias($primaryStorageHostAlias = null)
    {
        // validation for constraint: string
        if (!is_null($primaryStorageHostAlias) && !is_string($primaryStorageHostAlias)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($primaryStorageHostAlias, true), gettype($primaryStorageHostAlias)), __LINE__);
        }
        $this->primaryStorageHostAlias = $primaryStorageHostAlias;
        return $this;
    }
    /**
     * Get primaryStorageClientAlias value
     * @return string|null
     */
    public function getPrimaryStorageClientAlias()
    {
        return $this->primaryStorageClientAlias;
    }
    /**
     * Set primaryStorageClientAlias value
     * @param string $primaryStorageClientAlias
     * @return \StructType\XECMDocumentDisplayObjectOutputData
     */
    public function setPrimaryStorageClientAlias($primaryStorageClientAlias = null)
    {
        // validation for constraint: string
        if (!is_null($primaryStorageClientAlias) && !is_string($primaryStorageClientAlias)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($primaryStorageClientAlias, true), gettype($primaryStorageClientAlias)), __LINE__);
        }
        $this->primaryStorageClientAlias = $primaryStorageClientAlias;
        return $this;
    }
    /**
     * Get primaryStoragePath value
     * @return string|null
     */
    public function getPrimaryStoragePath()
    {
        return $this->primaryStoragePath;
    }
    /**
     * Set primaryStoragePath value
     * @param string $primaryStoragePath
     * @return \StructType\XECMDocumentDisplayObjectOutputData
     */
    public function setPrimaryStoragePath($primaryStoragePath = null)
    {
        // validation for constraint: string
        if (!is_null($primaryStoragePath) && !is_string($primaryStoragePath)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($primaryStoragePath, true), gettype($primaryStoragePath)), __LINE__);
        }
        $this->primaryStoragePath = $primaryStoragePath;
        return $this;
    }
    /**
     * Get mainSecondaryStorageAlias value
     * @return string|null
     */
    public function getMainSecondaryStorageAlias()
    {
        return $this->mainSecondaryStorageAlias;
    }
    /**
     * Set mainSecondaryStorageAlias value
     * @param string $mainSecondaryStorageAlias
     * @return \StructType\XECMDocumentDisplayObjectOutputData
     */
    public function setMainSecondaryStorageAlias($mainSecondaryStorageAlias = null)
    {
        // validation for constraint: string
        if (!is_null($mainSecondaryStorageAlias) && !is_string($mainSecondaryStorageAlias)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mainSecondaryStorageAlias, true), gettype($mainSecondaryStorageAlias)), __LINE__);
        }
        $this->mainSecondaryStorageAlias = $mainSecondaryStorageAlias;
        return $this;
    }
    /**
     * Get mainSecondaryStoragePath value
     * @return string|null
     */
    public function getMainSecondaryStoragePath()
    {
        return $this->mainSecondaryStoragePath;
    }
    /**
     * Set mainSecondaryStoragePath value
     * @param string $mainSecondaryStoragePath
     * @return \StructType\XECMDocumentDisplayObjectOutputData
     */
    public function setMainSecondaryStoragePath($mainSecondaryStoragePath = null)
    {
        // validation for constraint: string
        if (!is_null($mainSecondaryStoragePath) && !is_string($mainSecondaryStoragePath)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mainSecondaryStoragePath, true), gettype($mainSecondaryStoragePath)), __LINE__);
        }
        $this->mainSecondaryStoragePath = $mainSecondaryStoragePath;
        return $this;
    }
    /**
     * Get backupSecondaryStorageAlias value
     * @return string|null
     */
    public function getBackupSecondaryStorageAlias()
    {
        return $this->backupSecondaryStorageAlias;
    }
    /**
     * Set backupSecondaryStorageAlias value
     * @param string $backupSecondaryStorageAlias
     * @return \StructType\XECMDocumentDisplayObjectOutputData
     */
    public function setBackupSecondaryStorageAlias($backupSecondaryStorageAlias = null)
    {
        // validation for constraint: string
        if (!is_null($backupSecondaryStorageAlias) && !is_string($backupSecondaryStorageAlias)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($backupSecondaryStorageAlias, true), gettype($backupSecondaryStorageAlias)), __LINE__);
        }
        $this->backupSecondaryStorageAlias = $backupSecondaryStorageAlias;
        return $this;
    }
    /**
     * Get backupSecondaryStoragePath value
     * @return string|null
     */
    public function getBackupSecondaryStoragePath()
    {
        return $this->backupSecondaryStoragePath;
    }
    /**
     * Set backupSecondaryStoragePath value
     * @param string $backupSecondaryStoragePath
     * @return \StructType\XECMDocumentDisplayObjectOutputData
     */
    public function setBackupSecondaryStoragePath($backupSecondaryStoragePath = null)
    {
        // validation for constraint: string
        if (!is_null($backupSecondaryStoragePath) && !is_string($backupSecondaryStoragePath)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($backupSecondaryStoragePath, true), gettype($backupSecondaryStoragePath)), __LINE__);
        }
        $this->backupSecondaryStoragePath = $backupSecondaryStoragePath;
        return $this;
    }
    /**
     * Get isDisplayable value
     * @return string|null
     */
    public function getIsDisplayable()
    {
        return $this->isDisplayable;
    }
    /**
     * Set isDisplayable value
     * @param string $isDisplayable
     * @return \StructType\XECMDocumentDisplayObjectOutputData
     */
    public function setIsDisplayable($isDisplayable = null)
    {
        // validation for constraint: string
        if (!is_null($isDisplayable) && !is_string($isDisplayable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($isDisplayable, true), gettype($isDisplayable)), __LINE__);
        }
        $this->isDisplayable = $isDisplayable;
        return $this;
    }
    /**
     * Get ddapi91sOutputReserved value
     * @return string|null
     */
    public function getDdapi91sOutputReserved()
    {
        return $this->ddapi91sOutputReserved;
    }
    /**
     * Set ddapi91sOutputReserved value
     * @param string $ddapi91sOutputReserved
     * @return \StructType\XECMDocumentDisplayObjectOutputData
     */
    public function setDdapi91sOutputReserved($ddapi91sOutputReserved = null)
    {
        // validation for constraint: string
        if (!is_null($ddapi91sOutputReserved) && !is_string($ddapi91sOutputReserved)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ddapi91sOutputReserved, true), gettype($ddapi91sOutputReserved)), __LINE__);
        }
        $this->ddapi91sOutputReserved = $ddapi91sOutputReserved;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\XECMDocumentDisplayObjectOutputData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
