<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XECMDocumentGetCommentListOutputData StructType
 * @subpackage Structs
 */
class XECMDocumentGetCommentListOutputData extends AbstractStructBase
{
    /**
     * The ReturnedStatus
     * Meta information extracted from the WSDL
     * - nillable: false
     * @var string
     */
    public $ReturnedStatus;
    /**
     * The XECMDocumentGetCommentListOutputDataFetchedData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\XECMDocumentGetCommentListOutputDataFetchedData[]
     */
    public $XECMDocumentGetCommentListOutputDataFetchedData;
    /**
     * Constructor method for XECMDocumentGetCommentListOutputData
     * @uses XECMDocumentGetCommentListOutputData::setReturnedStatus()
     * @uses XECMDocumentGetCommentListOutputData::setXECMDocumentGetCommentListOutputDataFetchedData()
     * @param string $returnedStatus
     * @param \StructType\XECMDocumentGetCommentListOutputDataFetchedData[] $xECMDocumentGetCommentListOutputDataFetchedData
     */
    public function __construct($returnedStatus = null, array $xECMDocumentGetCommentListOutputDataFetchedData = array())
    {
        $this
            ->setReturnedStatus($returnedStatus)
            ->setXECMDocumentGetCommentListOutputDataFetchedData($xECMDocumentGetCommentListOutputDataFetchedData);
    }
    /**
     * Get ReturnedStatus value
     * @return string|null
     */
    public function getReturnedStatus()
    {
        return $this->ReturnedStatus;
    }
    /**
     * Set ReturnedStatus value
     * @param string $returnedStatus
     * @return \StructType\XECMDocumentGetCommentListOutputData
     */
    public function setReturnedStatus($returnedStatus = null)
    {
        // validation for constraint: string
        if (!is_null($returnedStatus) && !is_string($returnedStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($returnedStatus, true), gettype($returnedStatus)), __LINE__);
        }
        $this->ReturnedStatus = $returnedStatus;
        return $this;
    }
    /**
     * Get XECMDocumentGetCommentListOutputDataFetchedData value
     * @return \StructType\XECMDocumentGetCommentListOutputDataFetchedData[]|null
     */
    public function getXECMDocumentGetCommentListOutputDataFetchedData()
    {
        return $this->XECMDocumentGetCommentListOutputDataFetchedData;
    }
    /**
     * This method is responsible for validating the values passed to the setXECMDocumentGetCommentListOutputDataFetchedData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setXECMDocumentGetCommentListOutputDataFetchedData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateXECMDocumentGetCommentListOutputDataFetchedDataForArrayConstraintsFromSetXECMDocumentGetCommentListOutputDataFetchedData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $xECMDocumentGetCommentListOutputDataXECMDocumentGetCommentListOutputDataFetchedDataItem) {
            // validation for constraint: itemType
            if (!$xECMDocumentGetCommentListOutputDataXECMDocumentGetCommentListOutputDataFetchedDataItem instanceof \StructType\XECMDocumentGetCommentListOutputDataFetchedData) {
                $invalidValues[] = is_object($xECMDocumentGetCommentListOutputDataXECMDocumentGetCommentListOutputDataFetchedDataItem) ? get_class($xECMDocumentGetCommentListOutputDataXECMDocumentGetCommentListOutputDataFetchedDataItem) : sprintf('%s(%s)', gettype($xECMDocumentGetCommentListOutputDataXECMDocumentGetCommentListOutputDataFetchedDataItem), var_export($xECMDocumentGetCommentListOutputDataXECMDocumentGetCommentListOutputDataFetchedDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The XECMDocumentGetCommentListOutputDataFetchedData property can only contain items of type \StructType\XECMDocumentGetCommentListOutputDataFetchedData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set XECMDocumentGetCommentListOutputDataFetchedData value
     * @throws \InvalidArgumentException
     * @param \StructType\XECMDocumentGetCommentListOutputDataFetchedData[] $xECMDocumentGetCommentListOutputDataFetchedData
     * @return \StructType\XECMDocumentGetCommentListOutputData
     */
    public function setXECMDocumentGetCommentListOutputDataFetchedData(array $xECMDocumentGetCommentListOutputDataFetchedData = array())
    {
        // validation for constraint: array
        if ('' !== ($xECMDocumentGetCommentListOutputDataFetchedDataArrayErrorMessage = self::validateXECMDocumentGetCommentListOutputDataFetchedDataForArrayConstraintsFromSetXECMDocumentGetCommentListOutputDataFetchedData($xECMDocumentGetCommentListOutputDataFetchedData))) {
            throw new \InvalidArgumentException($xECMDocumentGetCommentListOutputDataFetchedDataArrayErrorMessage, __LINE__);
        }
        $this->XECMDocumentGetCommentListOutputDataFetchedData = $xECMDocumentGetCommentListOutputDataFetchedData;
        return $this;
    }
    /**
     * Add item to XECMDocumentGetCommentListOutputDataFetchedData value
     * @throws \InvalidArgumentException
     * @param \StructType\XECMDocumentGetCommentListOutputDataFetchedData $item
     * @return \StructType\XECMDocumentGetCommentListOutputData
     */
    public function addToXECMDocumentGetCommentListOutputDataFetchedData(\StructType\XECMDocumentGetCommentListOutputDataFetchedData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\XECMDocumentGetCommentListOutputDataFetchedData) {
            throw new \InvalidArgumentException(sprintf('The XECMDocumentGetCommentListOutputDataFetchedData property can only contain items of type \StructType\XECMDocumentGetCommentListOutputDataFetchedData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->XECMDocumentGetCommentListOutputDataFetchedData[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\XECMDocumentGetCommentListOutputData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
