<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XECMDocumentGetFolderListOutputData StructType
 * @subpackage Structs
 */
class XECMDocumentGetFolderListOutputData extends AbstractStructBase
{
    /**
     * The ReturnedStatus
     * Meta information extracted from the WSDL
     * - nillable: false
     * @var string
     */
    public $ReturnedStatus;
    /**
     * The XECMDocumentGetFolderListOutputDataFetchedData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\XECMDocumentGetFolderListOutputDataFetchedData[]
     */
    public $XECMDocumentGetFolderListOutputDataFetchedData;
    /**
     * Constructor method for XECMDocumentGetFolderListOutputData
     * @uses XECMDocumentGetFolderListOutputData::setReturnedStatus()
     * @uses XECMDocumentGetFolderListOutputData::setXECMDocumentGetFolderListOutputDataFetchedData()
     * @param string $returnedStatus
     * @param \StructType\XECMDocumentGetFolderListOutputDataFetchedData[] $xECMDocumentGetFolderListOutputDataFetchedData
     */
    public function __construct($returnedStatus = null, array $xECMDocumentGetFolderListOutputDataFetchedData = array())
    {
        $this
            ->setReturnedStatus($returnedStatus)
            ->setXECMDocumentGetFolderListOutputDataFetchedData($xECMDocumentGetFolderListOutputDataFetchedData);
    }
    /**
     * Get ReturnedStatus value
     * @return string|null
     */
    public function getReturnedStatus()
    {
        return $this->ReturnedStatus;
    }
    /**
     * Set ReturnedStatus value
     * @param string $returnedStatus
     * @return \StructType\XECMDocumentGetFolderListOutputData
     */
    public function setReturnedStatus($returnedStatus = null)
    {
        // validation for constraint: string
        if (!is_null($returnedStatus) && !is_string($returnedStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($returnedStatus, true), gettype($returnedStatus)), __LINE__);
        }
        $this->ReturnedStatus = $returnedStatus;
        return $this;
    }
    /**
     * Get XECMDocumentGetFolderListOutputDataFetchedData value
     * @return \StructType\XECMDocumentGetFolderListOutputDataFetchedData[]|null
     */
    public function getXECMDocumentGetFolderListOutputDataFetchedData()
    {
        return $this->XECMDocumentGetFolderListOutputDataFetchedData;
    }
    /**
     * This method is responsible for validating the values passed to the setXECMDocumentGetFolderListOutputDataFetchedData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setXECMDocumentGetFolderListOutputDataFetchedData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateXECMDocumentGetFolderListOutputDataFetchedDataForArrayConstraintsFromSetXECMDocumentGetFolderListOutputDataFetchedData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $xECMDocumentGetFolderListOutputDataXECMDocumentGetFolderListOutputDataFetchedDataItem) {
            // validation for constraint: itemType
            if (!$xECMDocumentGetFolderListOutputDataXECMDocumentGetFolderListOutputDataFetchedDataItem instanceof \StructType\XECMDocumentGetFolderListOutputDataFetchedData) {
                $invalidValues[] = is_object($xECMDocumentGetFolderListOutputDataXECMDocumentGetFolderListOutputDataFetchedDataItem) ? get_class($xECMDocumentGetFolderListOutputDataXECMDocumentGetFolderListOutputDataFetchedDataItem) : sprintf('%s(%s)', gettype($xECMDocumentGetFolderListOutputDataXECMDocumentGetFolderListOutputDataFetchedDataItem), var_export($xECMDocumentGetFolderListOutputDataXECMDocumentGetFolderListOutputDataFetchedDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The XECMDocumentGetFolderListOutputDataFetchedData property can only contain items of type \StructType\XECMDocumentGetFolderListOutputDataFetchedData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set XECMDocumentGetFolderListOutputDataFetchedData value
     * @throws \InvalidArgumentException
     * @param \StructType\XECMDocumentGetFolderListOutputDataFetchedData[] $xECMDocumentGetFolderListOutputDataFetchedData
     * @return \StructType\XECMDocumentGetFolderListOutputData
     */
    public function setXECMDocumentGetFolderListOutputDataFetchedData(array $xECMDocumentGetFolderListOutputDataFetchedData = array())
    {
        // validation for constraint: array
        if ('' !== ($xECMDocumentGetFolderListOutputDataFetchedDataArrayErrorMessage = self::validateXECMDocumentGetFolderListOutputDataFetchedDataForArrayConstraintsFromSetXECMDocumentGetFolderListOutputDataFetchedData($xECMDocumentGetFolderListOutputDataFetchedData))) {
            throw new \InvalidArgumentException($xECMDocumentGetFolderListOutputDataFetchedDataArrayErrorMessage, __LINE__);
        }
        $this->XECMDocumentGetFolderListOutputDataFetchedData = $xECMDocumentGetFolderListOutputDataFetchedData;
        return $this;
    }
    /**
     * Add item to XECMDocumentGetFolderListOutputDataFetchedData value
     * @throws \InvalidArgumentException
     * @param \StructType\XECMDocumentGetFolderListOutputDataFetchedData $item
     * @return \StructType\XECMDocumentGetFolderListOutputData
     */
    public function addToXECMDocumentGetFolderListOutputDataFetchedData(\StructType\XECMDocumentGetFolderListOutputDataFetchedData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\XECMDocumentGetFolderListOutputDataFetchedData) {
            throw new \InvalidArgumentException(sprintf('The XECMDocumentGetFolderListOutputDataFetchedData property can only contain items of type \StructType\XECMDocumentGetFolderListOutputDataFetchedData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->XECMDocumentGetFolderListOutputDataFetchedData[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\XECMDocumentGetFolderListOutputData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
