<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XECMDocumentGetKeywordListOutputData StructType
 * @subpackage Structs
 */
class XECMDocumentGetKeywordListOutputData extends AbstractStructBase
{
    /**
     * The ReturnedStatus
     * Meta information extracted from the WSDL
     * - nillable: false
     * @var string
     */
    public $ReturnedStatus;
    /**
     * The XECMDocumentGetKeywordListOutputDataFetchedData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\XECMDocumentGetKeywordListOutputDataFetchedData[]
     */
    public $XECMDocumentGetKeywordListOutputDataFetchedData;
    /**
     * Constructor method for XECMDocumentGetKeywordListOutputData
     * @uses XECMDocumentGetKeywordListOutputData::setReturnedStatus()
     * @uses XECMDocumentGetKeywordListOutputData::setXECMDocumentGetKeywordListOutputDataFetchedData()
     * @param string $returnedStatus
     * @param \StructType\XECMDocumentGetKeywordListOutputDataFetchedData[] $xECMDocumentGetKeywordListOutputDataFetchedData
     */
    public function __construct($returnedStatus = null, array $xECMDocumentGetKeywordListOutputDataFetchedData = array())
    {
        $this
            ->setReturnedStatus($returnedStatus)
            ->setXECMDocumentGetKeywordListOutputDataFetchedData($xECMDocumentGetKeywordListOutputDataFetchedData);
    }
    /**
     * Get ReturnedStatus value
     * @return string|null
     */
    public function getReturnedStatus()
    {
        return $this->ReturnedStatus;
    }
    /**
     * Set ReturnedStatus value
     * @param string $returnedStatus
     * @return \StructType\XECMDocumentGetKeywordListOutputData
     */
    public function setReturnedStatus($returnedStatus = null)
    {
        // validation for constraint: string
        if (!is_null($returnedStatus) && !is_string($returnedStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($returnedStatus, true), gettype($returnedStatus)), __LINE__);
        }
        $this->ReturnedStatus = $returnedStatus;
        return $this;
    }
    /**
     * Get XECMDocumentGetKeywordListOutputDataFetchedData value
     * @return \StructType\XECMDocumentGetKeywordListOutputDataFetchedData[]|null
     */
    public function getXECMDocumentGetKeywordListOutputDataFetchedData()
    {
        return $this->XECMDocumentGetKeywordListOutputDataFetchedData;
    }
    /**
     * This method is responsible for validating the values passed to the setXECMDocumentGetKeywordListOutputDataFetchedData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setXECMDocumentGetKeywordListOutputDataFetchedData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateXECMDocumentGetKeywordListOutputDataFetchedDataForArrayConstraintsFromSetXECMDocumentGetKeywordListOutputDataFetchedData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $xECMDocumentGetKeywordListOutputDataXECMDocumentGetKeywordListOutputDataFetchedDataItem) {
            // validation for constraint: itemType
            if (!$xECMDocumentGetKeywordListOutputDataXECMDocumentGetKeywordListOutputDataFetchedDataItem instanceof \StructType\XECMDocumentGetKeywordListOutputDataFetchedData) {
                $invalidValues[] = is_object($xECMDocumentGetKeywordListOutputDataXECMDocumentGetKeywordListOutputDataFetchedDataItem) ? get_class($xECMDocumentGetKeywordListOutputDataXECMDocumentGetKeywordListOutputDataFetchedDataItem) : sprintf('%s(%s)', gettype($xECMDocumentGetKeywordListOutputDataXECMDocumentGetKeywordListOutputDataFetchedDataItem), var_export($xECMDocumentGetKeywordListOutputDataXECMDocumentGetKeywordListOutputDataFetchedDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The XECMDocumentGetKeywordListOutputDataFetchedData property can only contain items of type \StructType\XECMDocumentGetKeywordListOutputDataFetchedData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set XECMDocumentGetKeywordListOutputDataFetchedData value
     * @throws \InvalidArgumentException
     * @param \StructType\XECMDocumentGetKeywordListOutputDataFetchedData[] $xECMDocumentGetKeywordListOutputDataFetchedData
     * @return \StructType\XECMDocumentGetKeywordListOutputData
     */
    public function setXECMDocumentGetKeywordListOutputDataFetchedData(array $xECMDocumentGetKeywordListOutputDataFetchedData = array())
    {
        // validation for constraint: array
        if ('' !== ($xECMDocumentGetKeywordListOutputDataFetchedDataArrayErrorMessage = self::validateXECMDocumentGetKeywordListOutputDataFetchedDataForArrayConstraintsFromSetXECMDocumentGetKeywordListOutputDataFetchedData($xECMDocumentGetKeywordListOutputDataFetchedData))) {
            throw new \InvalidArgumentException($xECMDocumentGetKeywordListOutputDataFetchedDataArrayErrorMessage, __LINE__);
        }
        $this->XECMDocumentGetKeywordListOutputDataFetchedData = $xECMDocumentGetKeywordListOutputDataFetchedData;
        return $this;
    }
    /**
     * Add item to XECMDocumentGetKeywordListOutputDataFetchedData value
     * @throws \InvalidArgumentException
     * @param \StructType\XECMDocumentGetKeywordListOutputDataFetchedData $item
     * @return \StructType\XECMDocumentGetKeywordListOutputData
     */
    public function addToXECMDocumentGetKeywordListOutputDataFetchedData(\StructType\XECMDocumentGetKeywordListOutputDataFetchedData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\XECMDocumentGetKeywordListOutputDataFetchedData) {
            throw new \InvalidArgumentException(sprintf('The XECMDocumentGetKeywordListOutputDataFetchedData property can only contain items of type \StructType\XECMDocumentGetKeywordListOutputDataFetchedData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->XECMDocumentGetKeywordListOutputDataFetchedData[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\XECMDocumentGetKeywordListOutputData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
