<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XECMDocumentGetListOutputData StructType
 * @subpackage Structs
 */
class XECMDocumentGetListOutputData extends AbstractStructBase
{
    /**
     * The ReturnedStatus
     * Meta information extracted from the WSDL
     * - nillable: false
     * @var string
     */
    public $ReturnedStatus;
    /**
     * The XECMDocumentGetListOutputDataFetchedData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\XECMDocumentGetListOutputDataFetchedData[]
     */
    public $XECMDocumentGetListOutputDataFetchedData;
    /**
     * Constructor method for XECMDocumentGetListOutputData
     * @uses XECMDocumentGetListOutputData::setReturnedStatus()
     * @uses XECMDocumentGetListOutputData::setXECMDocumentGetListOutputDataFetchedData()
     * @param string $returnedStatus
     * @param \StructType\XECMDocumentGetListOutputDataFetchedData[] $xECMDocumentGetListOutputDataFetchedData
     */
    public function __construct($returnedStatus = null, array $xECMDocumentGetListOutputDataFetchedData = array())
    {
        $this
            ->setReturnedStatus($returnedStatus)
            ->setXECMDocumentGetListOutputDataFetchedData($xECMDocumentGetListOutputDataFetchedData);
    }
    /**
     * Get ReturnedStatus value
     * @return string|null
     */
    public function getReturnedStatus()
    {
        return $this->ReturnedStatus;
    }
    /**
     * Set ReturnedStatus value
     * @param string $returnedStatus
     * @return \StructType\XECMDocumentGetListOutputData
     */
    public function setReturnedStatus($returnedStatus = null)
    {
        // validation for constraint: string
        if (!is_null($returnedStatus) && !is_string($returnedStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($returnedStatus, true), gettype($returnedStatus)), __LINE__);
        }
        $this->ReturnedStatus = $returnedStatus;
        return $this;
    }
    /**
     * Get XECMDocumentGetListOutputDataFetchedData value
     * @return \StructType\XECMDocumentGetListOutputDataFetchedData[]|null
     */
    public function getXECMDocumentGetListOutputDataFetchedData()
    {
        return $this->XECMDocumentGetListOutputDataFetchedData;
    }
    /**
     * This method is responsible for validating the values passed to the setXECMDocumentGetListOutputDataFetchedData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setXECMDocumentGetListOutputDataFetchedData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateXECMDocumentGetListOutputDataFetchedDataForArrayConstraintsFromSetXECMDocumentGetListOutputDataFetchedData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $xECMDocumentGetListOutputDataXECMDocumentGetListOutputDataFetchedDataItem) {
            // validation for constraint: itemType
            if (!$xECMDocumentGetListOutputDataXECMDocumentGetListOutputDataFetchedDataItem instanceof \StructType\XECMDocumentGetListOutputDataFetchedData) {
                $invalidValues[] = is_object($xECMDocumentGetListOutputDataXECMDocumentGetListOutputDataFetchedDataItem) ? get_class($xECMDocumentGetListOutputDataXECMDocumentGetListOutputDataFetchedDataItem) : sprintf('%s(%s)', gettype($xECMDocumentGetListOutputDataXECMDocumentGetListOutputDataFetchedDataItem), var_export($xECMDocumentGetListOutputDataXECMDocumentGetListOutputDataFetchedDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The XECMDocumentGetListOutputDataFetchedData property can only contain items of type \StructType\XECMDocumentGetListOutputDataFetchedData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set XECMDocumentGetListOutputDataFetchedData value
     * @throws \InvalidArgumentException
     * @param \StructType\XECMDocumentGetListOutputDataFetchedData[] $xECMDocumentGetListOutputDataFetchedData
     * @return \StructType\XECMDocumentGetListOutputData
     */
    public function setXECMDocumentGetListOutputDataFetchedData(array $xECMDocumentGetListOutputDataFetchedData = array())
    {
        // validation for constraint: array
        if ('' !== ($xECMDocumentGetListOutputDataFetchedDataArrayErrorMessage = self::validateXECMDocumentGetListOutputDataFetchedDataForArrayConstraintsFromSetXECMDocumentGetListOutputDataFetchedData($xECMDocumentGetListOutputDataFetchedData))) {
            throw new \InvalidArgumentException($xECMDocumentGetListOutputDataFetchedDataArrayErrorMessage, __LINE__);
        }
        $this->XECMDocumentGetListOutputDataFetchedData = $xECMDocumentGetListOutputDataFetchedData;
        return $this;
    }
    /**
     * Add item to XECMDocumentGetListOutputDataFetchedData value
     * @throws \InvalidArgumentException
     * @param \StructType\XECMDocumentGetListOutputDataFetchedData $item
     * @return \StructType\XECMDocumentGetListOutputData
     */
    public function addToXECMDocumentGetListOutputDataFetchedData(\StructType\XECMDocumentGetListOutputDataFetchedData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\XECMDocumentGetListOutputDataFetchedData) {
            throw new \InvalidArgumentException(sprintf('The XECMDocumentGetListOutputDataFetchedData property can only contain items of type \StructType\XECMDocumentGetListOutputDataFetchedData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->XECMDocumentGetListOutputDataFetchedData[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\XECMDocumentGetListOutputData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
