<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XECMDocumentGetVisaListOutputData StructType
 * @subpackage Structs
 */
class XECMDocumentGetVisaListOutputData extends AbstractStructBase
{
    /**
     * The ReturnedStatus
     * Meta information extracted from the WSDL
     * - nillable: false
     * @var string
     */
    public $ReturnedStatus;
    /**
     * The XECMDocumentGetVisaListOutputDataFetchedData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\XECMDocumentGetVisaListOutputDataFetchedData[]
     */
    public $XECMDocumentGetVisaListOutputDataFetchedData;
    /**
     * Constructor method for XECMDocumentGetVisaListOutputData
     * @uses XECMDocumentGetVisaListOutputData::setReturnedStatus()
     * @uses XECMDocumentGetVisaListOutputData::setXECMDocumentGetVisaListOutputDataFetchedData()
     * @param string $returnedStatus
     * @param \StructType\XECMDocumentGetVisaListOutputDataFetchedData[] $xECMDocumentGetVisaListOutputDataFetchedData
     */
    public function __construct($returnedStatus = null, array $xECMDocumentGetVisaListOutputDataFetchedData = array())
    {
        $this
            ->setReturnedStatus($returnedStatus)
            ->setXECMDocumentGetVisaListOutputDataFetchedData($xECMDocumentGetVisaListOutputDataFetchedData);
    }
    /**
     * Get ReturnedStatus value
     * @return string|null
     */
    public function getReturnedStatus()
    {
        return $this->ReturnedStatus;
    }
    /**
     * Set ReturnedStatus value
     * @param string $returnedStatus
     * @return \StructType\XECMDocumentGetVisaListOutputData
     */
    public function setReturnedStatus($returnedStatus = null)
    {
        // validation for constraint: string
        if (!is_null($returnedStatus) && !is_string($returnedStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($returnedStatus, true), gettype($returnedStatus)), __LINE__);
        }
        $this->ReturnedStatus = $returnedStatus;
        return $this;
    }
    /**
     * Get XECMDocumentGetVisaListOutputDataFetchedData value
     * @return \StructType\XECMDocumentGetVisaListOutputDataFetchedData[]|null
     */
    public function getXECMDocumentGetVisaListOutputDataFetchedData()
    {
        return $this->XECMDocumentGetVisaListOutputDataFetchedData;
    }
    /**
     * This method is responsible for validating the values passed to the setXECMDocumentGetVisaListOutputDataFetchedData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setXECMDocumentGetVisaListOutputDataFetchedData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateXECMDocumentGetVisaListOutputDataFetchedDataForArrayConstraintsFromSetXECMDocumentGetVisaListOutputDataFetchedData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $xECMDocumentGetVisaListOutputDataXECMDocumentGetVisaListOutputDataFetchedDataItem) {
            // validation for constraint: itemType
            if (!$xECMDocumentGetVisaListOutputDataXECMDocumentGetVisaListOutputDataFetchedDataItem instanceof \StructType\XECMDocumentGetVisaListOutputDataFetchedData) {
                $invalidValues[] = is_object($xECMDocumentGetVisaListOutputDataXECMDocumentGetVisaListOutputDataFetchedDataItem) ? get_class($xECMDocumentGetVisaListOutputDataXECMDocumentGetVisaListOutputDataFetchedDataItem) : sprintf('%s(%s)', gettype($xECMDocumentGetVisaListOutputDataXECMDocumentGetVisaListOutputDataFetchedDataItem), var_export($xECMDocumentGetVisaListOutputDataXECMDocumentGetVisaListOutputDataFetchedDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The XECMDocumentGetVisaListOutputDataFetchedData property can only contain items of type \StructType\XECMDocumentGetVisaListOutputDataFetchedData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set XECMDocumentGetVisaListOutputDataFetchedData value
     * @throws \InvalidArgumentException
     * @param \StructType\XECMDocumentGetVisaListOutputDataFetchedData[] $xECMDocumentGetVisaListOutputDataFetchedData
     * @return \StructType\XECMDocumentGetVisaListOutputData
     */
    public function setXECMDocumentGetVisaListOutputDataFetchedData(array $xECMDocumentGetVisaListOutputDataFetchedData = array())
    {
        // validation for constraint: array
        if ('' !== ($xECMDocumentGetVisaListOutputDataFetchedDataArrayErrorMessage = self::validateXECMDocumentGetVisaListOutputDataFetchedDataForArrayConstraintsFromSetXECMDocumentGetVisaListOutputDataFetchedData($xECMDocumentGetVisaListOutputDataFetchedData))) {
            throw new \InvalidArgumentException($xECMDocumentGetVisaListOutputDataFetchedDataArrayErrorMessage, __LINE__);
        }
        $this->XECMDocumentGetVisaListOutputDataFetchedData = $xECMDocumentGetVisaListOutputDataFetchedData;
        return $this;
    }
    /**
     * Add item to XECMDocumentGetVisaListOutputDataFetchedData value
     * @throws \InvalidArgumentException
     * @param \StructType\XECMDocumentGetVisaListOutputDataFetchedData $item
     * @return \StructType\XECMDocumentGetVisaListOutputData
     */
    public function addToXECMDocumentGetVisaListOutputDataFetchedData(\StructType\XECMDocumentGetVisaListOutputDataFetchedData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\XECMDocumentGetVisaListOutputDataFetchedData) {
            throw new \InvalidArgumentException(sprintf('The XECMDocumentGetVisaListOutputDataFetchedData property can only contain items of type \StructType\XECMDocumentGetVisaListOutputDataFetchedData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->XECMDocumentGetVisaListOutputDataFetchedData[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\XECMDocumentGetVisaListOutputData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
