<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XECMDocumentGetVisaListOutputDataFetchedData StructType
 * @subpackage Structs
 */
class XECMDocumentGetVisaListOutputDataFetchedData extends AbstractStructBase
{
    /**
     * The documentId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentId;
    /**
     * The databaseId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $databaseId;
    /**
     * The departmentId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $departmentId;
    /**
     * The documentTypeId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentTypeId;
    /**
     * The visaType
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $visaType;
    /**
     * The visaTypeDescription
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $visaTypeDescription;
    /**
     * The stampDate
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $stampDate;
    /**
     * The stampTime
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $stampTime;
    /**
     * The stampUser
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $stampUser;
    /**
     * The decision
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $decision;
    /**
     * The visaMandatory
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $visaMandatory;
    /**
     * Constructor method for XECMDocumentGetVisaListOutputDataFetchedData
     * @uses XECMDocumentGetVisaListOutputDataFetchedData::setDocumentId()
     * @uses XECMDocumentGetVisaListOutputDataFetchedData::setDatabaseId()
     * @uses XECMDocumentGetVisaListOutputDataFetchedData::setDepartmentId()
     * @uses XECMDocumentGetVisaListOutputDataFetchedData::setDocumentTypeId()
     * @uses XECMDocumentGetVisaListOutputDataFetchedData::setVisaType()
     * @uses XECMDocumentGetVisaListOutputDataFetchedData::setVisaTypeDescription()
     * @uses XECMDocumentGetVisaListOutputDataFetchedData::setStampDate()
     * @uses XECMDocumentGetVisaListOutputDataFetchedData::setStampTime()
     * @uses XECMDocumentGetVisaListOutputDataFetchedData::setStampUser()
     * @uses XECMDocumentGetVisaListOutputDataFetchedData::setDecision()
     * @uses XECMDocumentGetVisaListOutputDataFetchedData::setVisaMandatory()
     * @param string $documentId
     * @param string $databaseId
     * @param string $departmentId
     * @param string $documentTypeId
     * @param string $visaType
     * @param string $visaTypeDescription
     * @param string $stampDate
     * @param string $stampTime
     * @param string $stampUser
     * @param string $decision
     * @param string $visaMandatory
     */
    public function __construct($documentId = null, $databaseId = null, $departmentId = null, $documentTypeId = null, $visaType = null, $visaTypeDescription = null, $stampDate = null, $stampTime = null, $stampUser = null, $decision = null, $visaMandatory = null)
    {
        $this
            ->setDocumentId($documentId)
            ->setDatabaseId($databaseId)
            ->setDepartmentId($departmentId)
            ->setDocumentTypeId($documentTypeId)
            ->setVisaType($visaType)
            ->setVisaTypeDescription($visaTypeDescription)
            ->setStampDate($stampDate)
            ->setStampTime($stampTime)
            ->setStampUser($stampUser)
            ->setDecision($decision)
            ->setVisaMandatory($visaMandatory);
    }
    /**
     * Get documentId value
     * @return string|null
     */
    public function getDocumentId()
    {
        return $this->documentId;
    }
    /**
     * Set documentId value
     * @param string $documentId
     * @return \StructType\XECMDocumentGetVisaListOutputDataFetchedData
     */
    public function setDocumentId($documentId = null)
    {
        // validation for constraint: string
        if (!is_null($documentId) && !is_string($documentId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentId, true), gettype($documentId)), __LINE__);
        }
        $this->documentId = $documentId;
        return $this;
    }
    /**
     * Get databaseId value
     * @return string|null
     */
    public function getDatabaseId()
    {
        return $this->databaseId;
    }
    /**
     * Set databaseId value
     * @param string $databaseId
     * @return \StructType\XECMDocumentGetVisaListOutputDataFetchedData
     */
    public function setDatabaseId($databaseId = null)
    {
        // validation for constraint: string
        if (!is_null($databaseId) && !is_string($databaseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($databaseId, true), gettype($databaseId)), __LINE__);
        }
        $this->databaseId = $databaseId;
        return $this;
    }
    /**
     * Get departmentId value
     * @return string|null
     */
    public function getDepartmentId()
    {
        return $this->departmentId;
    }
    /**
     * Set departmentId value
     * @param string $departmentId
     * @return \StructType\XECMDocumentGetVisaListOutputDataFetchedData
     */
    public function setDepartmentId($departmentId = null)
    {
        // validation for constraint: string
        if (!is_null($departmentId) && !is_string($departmentId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($departmentId, true), gettype($departmentId)), __LINE__);
        }
        $this->departmentId = $departmentId;
        return $this;
    }
    /**
     * Get documentTypeId value
     * @return string|null
     */
    public function getDocumentTypeId()
    {
        return $this->documentTypeId;
    }
    /**
     * Set documentTypeId value
     * @param string $documentTypeId
     * @return \StructType\XECMDocumentGetVisaListOutputDataFetchedData
     */
    public function setDocumentTypeId($documentTypeId = null)
    {
        // validation for constraint: string
        if (!is_null($documentTypeId) && !is_string($documentTypeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentTypeId, true), gettype($documentTypeId)), __LINE__);
        }
        $this->documentTypeId = $documentTypeId;
        return $this;
    }
    /**
     * Get visaType value
     * @return string|null
     */
    public function getVisaType()
    {
        return $this->visaType;
    }
    /**
     * Set visaType value
     * @param string $visaType
     * @return \StructType\XECMDocumentGetVisaListOutputDataFetchedData
     */
    public function setVisaType($visaType = null)
    {
        // validation for constraint: string
        if (!is_null($visaType) && !is_string($visaType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($visaType, true), gettype($visaType)), __LINE__);
        }
        $this->visaType = $visaType;
        return $this;
    }
    /**
     * Get visaTypeDescription value
     * @return string|null
     */
    public function getVisaTypeDescription()
    {
        return $this->visaTypeDescription;
    }
    /**
     * Set visaTypeDescription value
     * @param string $visaTypeDescription
     * @return \StructType\XECMDocumentGetVisaListOutputDataFetchedData
     */
    public function setVisaTypeDescription($visaTypeDescription = null)
    {
        // validation for constraint: string
        if (!is_null($visaTypeDescription) && !is_string($visaTypeDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($visaTypeDescription, true), gettype($visaTypeDescription)), __LINE__);
        }
        $this->visaTypeDescription = $visaTypeDescription;
        return $this;
    }
    /**
     * Get stampDate value
     * @return string|null
     */
    public function getStampDate()
    {
        return $this->stampDate;
    }
    /**
     * Set stampDate value
     * @param string $stampDate
     * @return \StructType\XECMDocumentGetVisaListOutputDataFetchedData
     */
    public function setStampDate($stampDate = null)
    {
        // validation for constraint: string
        if (!is_null($stampDate) && !is_string($stampDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stampDate, true), gettype($stampDate)), __LINE__);
        }
        $this->stampDate = $stampDate;
        return $this;
    }
    /**
     * Get stampTime value
     * @return string|null
     */
    public function getStampTime()
    {
        return $this->stampTime;
    }
    /**
     * Set stampTime value
     * @param string $stampTime
     * @return \StructType\XECMDocumentGetVisaListOutputDataFetchedData
     */
    public function setStampTime($stampTime = null)
    {
        // validation for constraint: string
        if (!is_null($stampTime) && !is_string($stampTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stampTime, true), gettype($stampTime)), __LINE__);
        }
        $this->stampTime = $stampTime;
        return $this;
    }
    /**
     * Get stampUser value
     * @return string|null
     */
    public function getStampUser()
    {
        return $this->stampUser;
    }
    /**
     * Set stampUser value
     * @param string $stampUser
     * @return \StructType\XECMDocumentGetVisaListOutputDataFetchedData
     */
    public function setStampUser($stampUser = null)
    {
        // validation for constraint: string
        if (!is_null($stampUser) && !is_string($stampUser)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stampUser, true), gettype($stampUser)), __LINE__);
        }
        $this->stampUser = $stampUser;
        return $this;
    }
    /**
     * Get decision value
     * @return string|null
     */
    public function getDecision()
    {
        return $this->decision;
    }
    /**
     * Set decision value
     * @param string $decision
     * @return \StructType\XECMDocumentGetVisaListOutputDataFetchedData
     */
    public function setDecision($decision = null)
    {
        // validation for constraint: string
        if (!is_null($decision) && !is_string($decision)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($decision, true), gettype($decision)), __LINE__);
        }
        $this->decision = $decision;
        return $this;
    }
    /**
     * Get visaMandatory value
     * @return string|null
     */
    public function getVisaMandatory()
    {
        return $this->visaMandatory;
    }
    /**
     * Set visaMandatory value
     * @param string $visaMandatory
     * @return \StructType\XECMDocumentGetVisaListOutputDataFetchedData
     */
    public function setVisaMandatory($visaMandatory = null)
    {
        // validation for constraint: string
        if (!is_null($visaMandatory) && !is_string($visaMandatory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($visaMandatory, true), gettype($visaMandatory)), __LINE__);
        }
        $this->visaMandatory = $visaMandatory;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\XECMDocumentGetVisaListOutputDataFetchedData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
