<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XECMDocumentRestoreObjectInputData StructType
 * @subpackage Structs
 */
class XECMDocumentRestoreObjectInputData extends AbstractStructBase
{
    /**
     * The APIUserID
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $APIUserID;
    /**
     * The APIActionCode
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $APIActionCode;
    /**
     * The apiEnvironmentName
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $apiEnvironmentName;
    /**
     * The userIdLong
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $userIdLong;
    /**
     * The apiRightsCheck
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $apiRightsCheck;
    /**
     * The documentId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentId;
    /**
     * The databaseId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $databaseId;
    /**
     * The documentTypeId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentTypeId;
    /**
     * The keywordTypeId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $keywordTypeId;
    /**
     * The keywordValue
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $keywordValue;
    /**
     * The documentNumber
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentNumber;
    /**
     * The documentVersionNumberSearch
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $documentVersionNumberSearch;
    /**
     * The DocumentRestoreType
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $DocumentRestoreType;
    /**
     * The DDAPI146SInputReserved
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $DDAPI146SInputReserved;
    /**
     * Constructor method for XECMDocumentRestoreObjectInputData
     * @uses XECMDocumentRestoreObjectInputData::setAPIUserID()
     * @uses XECMDocumentRestoreObjectInputData::setAPIActionCode()
     * @uses XECMDocumentRestoreObjectInputData::setApiEnvironmentName()
     * @uses XECMDocumentRestoreObjectInputData::setUserIdLong()
     * @uses XECMDocumentRestoreObjectInputData::setApiRightsCheck()
     * @uses XECMDocumentRestoreObjectInputData::setDocumentId()
     * @uses XECMDocumentRestoreObjectInputData::setDatabaseId()
     * @uses XECMDocumentRestoreObjectInputData::setDocumentTypeId()
     * @uses XECMDocumentRestoreObjectInputData::setKeywordTypeId()
     * @uses XECMDocumentRestoreObjectInputData::setKeywordValue()
     * @uses XECMDocumentRestoreObjectInputData::setDocumentNumber()
     * @uses XECMDocumentRestoreObjectInputData::setDocumentVersionNumberSearch()
     * @uses XECMDocumentRestoreObjectInputData::setDocumentRestoreType()
     * @uses XECMDocumentRestoreObjectInputData::setDDAPI146SInputReserved()
     * @param string $aPIUserID
     * @param string $aPIActionCode
     * @param string $apiEnvironmentName
     * @param string $userIdLong
     * @param string $apiRightsCheck
     * @param string $documentId
     * @param string $databaseId
     * @param string $documentTypeId
     * @param string $keywordTypeId
     * @param string $keywordValue
     * @param string $documentNumber
     * @param string $documentVersionNumberSearch
     * @param string $documentRestoreType
     * @param string $dDAPI146SInputReserved
     */
    public function __construct($aPIUserID = null, $aPIActionCode = null, $apiEnvironmentName = null, $userIdLong = null, $apiRightsCheck = null, $documentId = null, $databaseId = null, $documentTypeId = null, $keywordTypeId = null, $keywordValue = null, $documentNumber = null, $documentVersionNumberSearch = null, $documentRestoreType = null, $dDAPI146SInputReserved = null)
    {
        $this
            ->setAPIUserID($aPIUserID)
            ->setAPIActionCode($aPIActionCode)
            ->setApiEnvironmentName($apiEnvironmentName)
            ->setUserIdLong($userIdLong)
            ->setApiRightsCheck($apiRightsCheck)
            ->setDocumentId($documentId)
            ->setDatabaseId($databaseId)
            ->setDocumentTypeId($documentTypeId)
            ->setKeywordTypeId($keywordTypeId)
            ->setKeywordValue($keywordValue)
            ->setDocumentNumber($documentNumber)
            ->setDocumentVersionNumberSearch($documentVersionNumberSearch)
            ->setDocumentRestoreType($documentRestoreType)
            ->setDDAPI146SInputReserved($dDAPI146SInputReserved);
    }
    /**
     * Get APIUserID value
     * @return string|null
     */
    public function getAPIUserID()
    {
        return $this->APIUserID;
    }
    /**
     * Set APIUserID value
     * @param string $aPIUserID
     * @return \StructType\XECMDocumentRestoreObjectInputData
     */
    public function setAPIUserID($aPIUserID = null)
    {
        // validation for constraint: string
        if (!is_null($aPIUserID) && !is_string($aPIUserID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aPIUserID, true), gettype($aPIUserID)), __LINE__);
        }
        $this->APIUserID = $aPIUserID;
        return $this;
    }
    /**
     * Get APIActionCode value
     * @return string|null
     */
    public function getAPIActionCode()
    {
        return $this->APIActionCode;
    }
    /**
     * Set APIActionCode value
     * @param string $aPIActionCode
     * @return \StructType\XECMDocumentRestoreObjectInputData
     */
    public function setAPIActionCode($aPIActionCode = null)
    {
        // validation for constraint: string
        if (!is_null($aPIActionCode) && !is_string($aPIActionCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aPIActionCode, true), gettype($aPIActionCode)), __LINE__);
        }
        $this->APIActionCode = $aPIActionCode;
        return $this;
    }
    /**
     * Get apiEnvironmentName value
     * @return string|null
     */
    public function getApiEnvironmentName()
    {
        return $this->apiEnvironmentName;
    }
    /**
     * Set apiEnvironmentName value
     * @param string $apiEnvironmentName
     * @return \StructType\XECMDocumentRestoreObjectInputData
     */
    public function setApiEnvironmentName($apiEnvironmentName = null)
    {
        // validation for constraint: string
        if (!is_null($apiEnvironmentName) && !is_string($apiEnvironmentName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($apiEnvironmentName, true), gettype($apiEnvironmentName)), __LINE__);
        }
        $this->apiEnvironmentName = $apiEnvironmentName;
        return $this;
    }
    /**
     * Get userIdLong value
     * @return string|null
     */
    public function getUserIdLong()
    {
        return $this->userIdLong;
    }
    /**
     * Set userIdLong value
     * @param string $userIdLong
     * @return \StructType\XECMDocumentRestoreObjectInputData
     */
    public function setUserIdLong($userIdLong = null)
    {
        // validation for constraint: string
        if (!is_null($userIdLong) && !is_string($userIdLong)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userIdLong, true), gettype($userIdLong)), __LINE__);
        }
        $this->userIdLong = $userIdLong;
        return $this;
    }
    /**
     * Get apiRightsCheck value
     * @return string|null
     */
    public function getApiRightsCheck()
    {
        return $this->apiRightsCheck;
    }
    /**
     * Set apiRightsCheck value
     * @param string $apiRightsCheck
     * @return \StructType\XECMDocumentRestoreObjectInputData
     */
    public function setApiRightsCheck($apiRightsCheck = null)
    {
        // validation for constraint: string
        if (!is_null($apiRightsCheck) && !is_string($apiRightsCheck)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($apiRightsCheck, true), gettype($apiRightsCheck)), __LINE__);
        }
        $this->apiRightsCheck = $apiRightsCheck;
        return $this;
    }
    /**
     * Get documentId value
     * @return string|null
     */
    public function getDocumentId()
    {
        return $this->documentId;
    }
    /**
     * Set documentId value
     * @param string $documentId
     * @return \StructType\XECMDocumentRestoreObjectInputData
     */
    public function setDocumentId($documentId = null)
    {
        // validation for constraint: string
        if (!is_null($documentId) && !is_string($documentId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentId, true), gettype($documentId)), __LINE__);
        }
        $this->documentId = $documentId;
        return $this;
    }
    /**
     * Get databaseId value
     * @return string|null
     */
    public function getDatabaseId()
    {
        return $this->databaseId;
    }
    /**
     * Set databaseId value
     * @param string $databaseId
     * @return \StructType\XECMDocumentRestoreObjectInputData
     */
    public function setDatabaseId($databaseId = null)
    {
        // validation for constraint: string
        if (!is_null($databaseId) && !is_string($databaseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($databaseId, true), gettype($databaseId)), __LINE__);
        }
        $this->databaseId = $databaseId;
        return $this;
    }
    /**
     * Get documentTypeId value
     * @return string|null
     */
    public function getDocumentTypeId()
    {
        return $this->documentTypeId;
    }
    /**
     * Set documentTypeId value
     * @param string $documentTypeId
     * @return \StructType\XECMDocumentRestoreObjectInputData
     */
    public function setDocumentTypeId($documentTypeId = null)
    {
        // validation for constraint: string
        if (!is_null($documentTypeId) && !is_string($documentTypeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentTypeId, true), gettype($documentTypeId)), __LINE__);
        }
        $this->documentTypeId = $documentTypeId;
        return $this;
    }
    /**
     * Get keywordTypeId value
     * @return string|null
     */
    public function getKeywordTypeId()
    {
        return $this->keywordTypeId;
    }
    /**
     * Set keywordTypeId value
     * @param string $keywordTypeId
     * @return \StructType\XECMDocumentRestoreObjectInputData
     */
    public function setKeywordTypeId($keywordTypeId = null)
    {
        // validation for constraint: string
        if (!is_null($keywordTypeId) && !is_string($keywordTypeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($keywordTypeId, true), gettype($keywordTypeId)), __LINE__);
        }
        $this->keywordTypeId = $keywordTypeId;
        return $this;
    }
    /**
     * Get keywordValue value
     * @return string|null
     */
    public function getKeywordValue()
    {
        return $this->keywordValue;
    }
    /**
     * Set keywordValue value
     * @param string $keywordValue
     * @return \StructType\XECMDocumentRestoreObjectInputData
     */
    public function setKeywordValue($keywordValue = null)
    {
        // validation for constraint: string
        if (!is_null($keywordValue) && !is_string($keywordValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($keywordValue, true), gettype($keywordValue)), __LINE__);
        }
        $this->keywordValue = $keywordValue;
        return $this;
    }
    /**
     * Get documentNumber value
     * @return string|null
     */
    public function getDocumentNumber()
    {
        return $this->documentNumber;
    }
    /**
     * Set documentNumber value
     * @param string $documentNumber
     * @return \StructType\XECMDocumentRestoreObjectInputData
     */
    public function setDocumentNumber($documentNumber = null)
    {
        // validation for constraint: string
        if (!is_null($documentNumber) && !is_string($documentNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentNumber, true), gettype($documentNumber)), __LINE__);
        }
        $this->documentNumber = $documentNumber;
        return $this;
    }
    /**
     * Get documentVersionNumberSearch value
     * @return string|null
     */
    public function getDocumentVersionNumberSearch()
    {
        return $this->documentVersionNumberSearch;
    }
    /**
     * Set documentVersionNumberSearch value
     * @param string $documentVersionNumberSearch
     * @return \StructType\XECMDocumentRestoreObjectInputData
     */
    public function setDocumentVersionNumberSearch($documentVersionNumberSearch = null)
    {
        // validation for constraint: string
        if (!is_null($documentVersionNumberSearch) && !is_string($documentVersionNumberSearch)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentVersionNumberSearch, true), gettype($documentVersionNumberSearch)), __LINE__);
        }
        $this->documentVersionNumberSearch = $documentVersionNumberSearch;
        return $this;
    }
    /**
     * Get DocumentRestoreType value
     * @return string|null
     */
    public function getDocumentRestoreType()
    {
        return $this->DocumentRestoreType;
    }
    /**
     * Set DocumentRestoreType value
     * @param string $documentRestoreType
     * @return \StructType\XECMDocumentRestoreObjectInputData
     */
    public function setDocumentRestoreType($documentRestoreType = null)
    {
        // validation for constraint: string
        if (!is_null($documentRestoreType) && !is_string($documentRestoreType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentRestoreType, true), gettype($documentRestoreType)), __LINE__);
        }
        $this->DocumentRestoreType = $documentRestoreType;
        return $this;
    }
    /**
     * Get DDAPI146SInputReserved value
     * @return string|null
     */
    public function getDDAPI146SInputReserved()
    {
        return $this->DDAPI146SInputReserved;
    }
    /**
     * Set DDAPI146SInputReserved value
     * @param string $dDAPI146SInputReserved
     * @return \StructType\XECMDocumentRestoreObjectInputData
     */
    public function setDDAPI146SInputReserved($dDAPI146SInputReserved = null)
    {
        // validation for constraint: string
        if (!is_null($dDAPI146SInputReserved) && !is_string($dDAPI146SInputReserved)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dDAPI146SInputReserved, true), gettype($dDAPI146SInputReserved)), __LINE__);
        }
        $this->DDAPI146SInputReserved = $dDAPI146SInputReserved;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\XECMDocumentRestoreObjectInputData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
