<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XECMDocumentSendFlowObjectOutputData StructType
 * @subpackage Structs
 */
class XECMDocumentSendFlowObjectOutputData extends AbstractStructBase
{
    /**
     * The ReturnedStatus
     * Meta information extracted from the WSDL
     * - nillable: false
     * @var string
     */
    public $ReturnedStatus;
    /**
     * The ddapi153SReturnCode
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $ddapi153SReturnCode;
    /**
     * The DominoServerName
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $DominoServerName;
    /**
     * The dominoDatabase
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $dominoDatabase;
    /**
     * The ddapi153SOutputReserved
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $ddapi153SOutputReserved;
    /**
     * Constructor method for XECMDocumentSendFlowObjectOutputData
     * @uses XECMDocumentSendFlowObjectOutputData::setReturnedStatus()
     * @uses XECMDocumentSendFlowObjectOutputData::setDdapi153SReturnCode()
     * @uses XECMDocumentSendFlowObjectOutputData::setDominoServerName()
     * @uses XECMDocumentSendFlowObjectOutputData::setDominoDatabase()
     * @uses XECMDocumentSendFlowObjectOutputData::setDdapi153SOutputReserved()
     * @param string $returnedStatus
     * @param string $ddapi153SReturnCode
     * @param string $dominoServerName
     * @param string $dominoDatabase
     * @param string $ddapi153SOutputReserved
     */
    public function __construct($returnedStatus = null, $ddapi153SReturnCode = null, $dominoServerName = null, $dominoDatabase = null, $ddapi153SOutputReserved = null)
    {
        $this
            ->setReturnedStatus($returnedStatus)
            ->setDdapi153SReturnCode($ddapi153SReturnCode)
            ->setDominoServerName($dominoServerName)
            ->setDominoDatabase($dominoDatabase)
            ->setDdapi153SOutputReserved($ddapi153SOutputReserved);
    }
    /**
     * Get ReturnedStatus value
     * @return string|null
     */
    public function getReturnedStatus()
    {
        return $this->ReturnedStatus;
    }
    /**
     * Set ReturnedStatus value
     * @param string $returnedStatus
     * @return \StructType\XECMDocumentSendFlowObjectOutputData
     */
    public function setReturnedStatus($returnedStatus = null)
    {
        // validation for constraint: string
        if (!is_null($returnedStatus) && !is_string($returnedStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($returnedStatus, true), gettype($returnedStatus)), __LINE__);
        }
        $this->ReturnedStatus = $returnedStatus;
        return $this;
    }
    /**
     * Get ddapi153SReturnCode value
     * @return string|null
     */
    public function getDdapi153SReturnCode()
    {
        return $this->ddapi153SReturnCode;
    }
    /**
     * Set ddapi153SReturnCode value
     * @param string $ddapi153SReturnCode
     * @return \StructType\XECMDocumentSendFlowObjectOutputData
     */
    public function setDdapi153SReturnCode($ddapi153SReturnCode = null)
    {
        // validation for constraint: string
        if (!is_null($ddapi153SReturnCode) && !is_string($ddapi153SReturnCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ddapi153SReturnCode, true), gettype($ddapi153SReturnCode)), __LINE__);
        }
        $this->ddapi153SReturnCode = $ddapi153SReturnCode;
        return $this;
    }
    /**
     * Get DominoServerName value
     * @return string|null
     */
    public function getDominoServerName()
    {
        return $this->DominoServerName;
    }
    /**
     * Set DominoServerName value
     * @param string $dominoServerName
     * @return \StructType\XECMDocumentSendFlowObjectOutputData
     */
    public function setDominoServerName($dominoServerName = null)
    {
        // validation for constraint: string
        if (!is_null($dominoServerName) && !is_string($dominoServerName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dominoServerName, true), gettype($dominoServerName)), __LINE__);
        }
        $this->DominoServerName = $dominoServerName;
        return $this;
    }
    /**
     * Get dominoDatabase value
     * @return string|null
     */
    public function getDominoDatabase()
    {
        return $this->dominoDatabase;
    }
    /**
     * Set dominoDatabase value
     * @param string $dominoDatabase
     * @return \StructType\XECMDocumentSendFlowObjectOutputData
     */
    public function setDominoDatabase($dominoDatabase = null)
    {
        // validation for constraint: string
        if (!is_null($dominoDatabase) && !is_string($dominoDatabase)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dominoDatabase, true), gettype($dominoDatabase)), __LINE__);
        }
        $this->dominoDatabase = $dominoDatabase;
        return $this;
    }
    /**
     * Get ddapi153SOutputReserved value
     * @return string|null
     */
    public function getDdapi153SOutputReserved()
    {
        return $this->ddapi153SOutputReserved;
    }
    /**
     * Set ddapi153SOutputReserved value
     * @param string $ddapi153SOutputReserved
     * @return \StructType\XECMDocumentSendFlowObjectOutputData
     */
    public function setDdapi153SOutputReserved($ddapi153SOutputReserved = null)
    {
        // validation for constraint: string
        if (!is_null($ddapi153SOutputReserved) && !is_string($ddapi153SOutputReserved)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ddapi153SOutputReserved, true), gettype($ddapi153SOutputReserved)), __LINE__);
        }
        $this->ddapi153SOutputReserved = $ddapi153SOutputReserved;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\XECMDocumentSendFlowObjectOutputData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
